% Los requisitos especificados en IS-GPS-800F deben pertenecer a la seal 
% contenida dentro de un ancho de banda de 30,69 MHz centrado sobre 
% la frecuencia nominal L1.
ABTotal= 30.69e6;       %Ancho de banda L1C especificado en IS-GPS-800F
fc=1.023e6;             %Frecuencia de chip fc=nx1.023
fs=1.023e6;             %Frecuencia de subportadora fs=mx1.023
fsamp=120*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
k=-(N-1)/2:(N-1)/2;
df=fsamp/N;
%f=k*df;
frec_ABTotal=-(ABTotal/2):10:(ABTotal/2);        % Limites de integracion, Ancho de Banda
f=frec_ABTotal;
cd=[1 -1 -1 1 -1];      %Secuencia de datos
%******** BOC(6,1) *********
m=6;
n=1;
%phi61=2*(m/n);                    %is defined as two times the ratio between the sub-carrier and the chip frequency
n161=sin((pi*f)/(2*m*fs));
n261=sin((pi*f)/(n*fc));
q161=pi*f;
q261=cos((pi*f)/(2*m*fs));
n61=n161.*n261;
q61=q161.*q261;
fract61=n61./q61;
boc61=fc*((fract61).^2);
Ton61=1/(2*m*fc);                             %Tiempo en ON de la seal BOC(6,1) con m=6
%frec_ABTotal=-(ABTotal/2):1:(ABTotal/2);    % Limites de integracion, Ancho de Banda
S61=Ton61*sinc(frec_ABTotal*Ton61);         %S(f):Transformada de Fourier pulso rect
ABTotal_Num61=sum(((2*pi*frec_ABTotal).^2).*(abs(S61).^2)); 
ABTotal_Den61=sum(abs(S61).^2);
Bms_BOC61 = ABTotal_Num61/ABTotal_Den61;       %AB RMS (Hz^2)
%boc61l=10*log10(boc61);
%******** BOC(1,1) *********
m=1;
n=1;
%phi11=2*(m/n);                    %is defined as two times the ratio between the sub-carrier and the chip frequency
n111=sin((pi*f)/(2*m*fs));
n211=sin((pi*f)/(n*fc));
q111=pi*f;
q211=cos((pi*f)/(2*m*fs));
n11=n111.*n211;
q11=q111.*q211;
fract11=n11./q11;
boc11=fc*((fract11).^2);
Ton11=1/(2*m*fc);                 %Tiempo en ON de la seal BOC(1,1) con m=1
%boc11l=10*log10(boc11);
%**** MBOC(6,1,1/11)
L1Cp=(10/11)*boc11+(1/11)*boc61;
[ind] = find(isnan(L1Cp));
L1Cp(ind)=L1Cp(ind-1);
L1Cpl=10*log10(L1Cp);
%Clculo del ancho de banda cuadratico medio de la BOC(6,1)        
S11=Ton11*sinc(frec_ABTotal*Ton11);         %S(f):Transformada de Fourier pulso rect
ABTotal_Num11=sum(((2*pi*frec_ABTotal).^2).*(abs(S11).^2)); 
ABTotal_Den11=sum(abs(S11).^2);
Bms_BOC11 = ABTotal_Num11/ABTotal_Den11;    %AB RMS (Hz^2)
%**** Clculo del ancho de banda cuadratico medio de L1Cpilot
TF_L1Cpilot = L1Cp;
ABTotal_Num_L1Cpilot=sum(((2*pi*frec_ABTotal).^2).*(abs(TF_L1Cpilot).^2),'omitnan'); 
ABTotal_Den_L1Cpilot=sum(abs(TF_L1Cpilot).^2,'omitnan');
Bms_L1Cpilot = ABTotal_Num_L1Cpilot/ABTotal_Den_L1Cpilot;    %AB RMS (Hz^2) 
BW_L1Cpilot = sqrt(Bms_L1Cpilot);                            %AB RMS (Hz)

% ACF=ifftshift(ifft(ifftshift(L1Cp)));
% ACF=N*abs(ACF);
% ACF=ACF/max(ACF);
% plot(f,ACF)
% xlim([-500 500]);
% ylim([min(ACF)-0.5 max(ACF)*1.2]);

PL1CDmin=5.01187e-17;
PL1CPmin=1.496235e-16;
Esmin=Ton61*PL1CPmin;
Ta=290;
kb=1.38064e-23;
No=kb*Ta;
VarCRL1CP=1/(((2*Esmin)/No)*(BW_L1Cpilot^2));
Precision_Distancia_L1C=sqrt(VarCRL1CP)*3e8; %Precisin en la peor medida de distancia (m).

ABTotal= 30.69e6;       %Ancho de banda L2C especificado en IS-GPS-200J
frec_ABTotal=-(ABTotal/2):10:(ABTotal/2);        % Limites de integracion, Ancho de Banda
fc= 1.023e6;
fs= 1.023e6;
fsamp=120*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
TonL2C=1/1.023e6;
f=frec_ABTotal;
S = sinc((1/fc)*frec_ABTotal); 
aux = sum(abs(S).^2)/length(S); 
S = S/sqrt(aux);
S_L2C = abs(S).^2;
S_L2Cl=10*log10(S_L2C);

% S2 = (1/fc)*(sinc(frec_ABTotal/fc));
% S1_L2C = abs(S).^2;
%TF_L1Cpilot = L1Cp;
ABTotal_Num_L2C=sum(((2*pi*frec_ABTotal).^2).*(abs(S_L2C).^2),'omitnan'); 
ABTotal_Den_L2C=sum(abs(S_L2C).^2,'omitnan');
Bms_L2C = ABTotal_Num_L2C/ABTotal_Den_L2C;    %AB RMS (Hz^2) 
BW_L2C = sqrt(Bms_L2C);                            %AB RMS (Hz)  

% ACF=ifftshift(ifft(ifftshift(S_L2C)));
% ACF=N*abs(ACF);
% ACF=ACF/max(ACF);
% plot(f,ACF)
% xlim([-500 500]);
% ylim([min(ACF)-0.5 max(ACF)*1.2]);

PL2Cmin=1.412537e-16;
Esmin=TonL2C*PL2Cmin;
Ta=290;
kb=1.38064e-23;
No=kb*Ta;
VarCRL2C=1/(((2*Esmin)/No)*(BW_L2C^2));
Precision_Distancia_L2C=sqrt(VarCRL2C)*3e8; %Precisin en la peor medida de distancia (m).

%==========================================================================
% L5 BPSK of chipping rate fc.
%--------------------------------------------------------------------------
ABTotal2= 24e6;       %Ancho de banda L2C especificado en IS-GPS-200J
frec_ABTotal2=-(ABTotal2/2):10:(ABTotal2/2);        % Limites de integracion, Ancho de Banda
fc= 10.023e6;
fs= 1.023e6;
fsamp=120*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
TonL5=1/1.023e6;
f=frec_ABTotal2;
S = sinc((1/fc)*frec_ABTotal2); 
aux = sum(abs(S).^2)/length(S); 
S = S/sqrt(aux);
S_L5 = abs(S).^2;
S_L5l=10*log10(S_L5);

% S2 = (1/fc)*(sinc(frec_ABTotal/fc));
% S1_L2C = abs(S).^2;
%TF_L1Cpilot = L1Cp;
ABTotal_Num_L5=sum(((2*pi*frec_ABTotal2).^2).*(abs(S_L5).^2),'omitnan'); 
ABTotal_Den_L5=sum(abs(S_L5).^2,'omitnan');
Bms_L5 = ABTotal_Num_L5/ABTotal_Den_L5;    %AB RMS (Hz^2) 
BW_L5 = sqrt(Bms_L5);                            %AB RMS (Hz)  

% ACF=ifftshift(ifft(ifftshift(S_L5)));
% ACF=N*abs(ACF);
% ACF=ACF/max(ACF);
% %Z = interp1((linspace(-1, 1, length(Z))), ACF, (linspace(-1, 1, r*length(Z)-1)));
% plot(f,ACF)
% xlim([-500 500]);
% ylim([min(ACF)-0.5 max(ACF)*1.2]);

PL5min=3.235936e-16;
Esmin=TonL5*PL5min;
Ta=290;
kb=1.38064e-23;
No=kb*Ta;
VarCRL5=1/(((2*Esmin)/No)*(BW_L5^2));
Precision_Distancia_L5=sqrt(VarCRL5)*3e8; %Precisin en la peor medida de distancia (m). 

diff_BW = [BW_L1Cpilot BW_L2C BW_L5];
b=bar(diff_BW);
ax = gca;
ax.XTick = [1 2 3]; 
ax.XTickLabels = {'L1C','L2C','L5'};
b.FaceColor='flat';
b.CData(2,:)=[1 0.75 0];
b.CData(3,:)=[1 0.5 0];
ylabel('Frequency (MHz)');
grid on;
title('RMS BW');

figure;
%hold on;
subplot(3,1,1);

plot(frec_ABTotal/1e6,L1Cpl,'color','b','LineWidth',2);
ylim([-120 -60]);
xlim([-15 15]);
ylabel('L1C');
title('Densidad Espectral de Potencia');
subplot(3,1,2);
plot(frec_ABTotal/1e6,S_L2Cl,'color','m','LineWidth',2);
ylim([-40 20]);
xlim([-15 15]);
ylabel('L2C');
subplot(3,1,3);
plot(frec_ABTotal2/1e6,S_L5l,'color','r','LineWidth',2);
ylim([-60 10]);
xlim([-12 12]);
ylabel('L5');
xlabel('Frequency (MHz)');
%hold off;

figure;
diff_BW = [Precision_Distancia_L1C Precision_Distancia_L2C Precision_Distancia_L5];
b=bar(diff_BW);
ax = gca;
ax.XTick = [1 2 3]; 
ax.XTickLabels = {'L1C','L2C','L5'};
b.FaceColor='flat';
b.CData(2,:)=[1 0.75 0.5];
b.CData(3,:)=[0.5 0.5 0.75];
ylabel('Distancia (m)');
grid on;
title('Precisin en la peor medida'); %Precisin que proporciona el radar SSR en la peor medida de distancia. 

