%close all; clc; clear;
%Compares Power Spectral density (PSD) of different BOC(fs,fc) modulations.
ABTotal= 30.69e6; 
fc=1.023e6;             %Frecuencia de chip fc=n?1.023
fs=1.023e6;             %Frecuencia de subportadora fs=m?1.023
m=1;
n=1;
phi=2*(m/n);            %is defined as two times the ratio between the sub-carrier and the chip frequency
fsamp=60*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
k=-(N-1)/2:(N-1)/2;
df=fsamp/N;
f=k*df;
frec_ABTotal=-(ABTotal/2):50:(ABTotal/2);        % Limites de integracion, Ancho de Banda
f=frec_ABTotal;
cd=[1 -1 -1 1 -1];      %Secuencia de datos
%*************************************Stadistics of a BOCsin(1,1)
%Usamos la expresion o formula ideal para el calculo de BOCsin(fs,fc)
m=1;
n=1;
n1s=sin((pi*f)/(2*m*fs));         %Primer elemento num
n2s=sin((pi*f)/(n*fc));           %Segundo elemento num
q1s=pi*f;                       %Primer elemento den
q2s=cos((pi*f)/(2*m*fc));         %Segundo elemento den
ns=n1s.*n2s;                    %Numerador completo
qs=q1s.*q2s;                    %Denominador completo
fracts=ns./qs;
Gbocs=fc*(fracts).^2;
% Rggs=ifftshift(ifft(ifftshift(Gbocs)));
% Rggs=N*abs(Rggs);
% Rggs=Rggs/max(Rggs);
% Gbocsl=10*log10(Gbocs);           %Transformacion logaritmica dBW
%Autocorrelacion
r=10;               %Resolucion
autocorrelador();
mpath4();
check_signal();
representa3();

%************************************Stadistics of a BOCsin(6,1)
n1sf=sin((pi*f)/(2*6*fs));
n2sf=sin((pi*f)/(fc));
q1sf=pi*f;
q2sf=cos((pi*f)/(2*6*fs));
nsf=n1sf.*n2sf;
qsf=q1sf.*q2sf;
fractsf=nsf./qsf;
Gbocsf=fc*((fractsf).^2);
Rggsf=ifftshift(ifft(ifftshift(Gbocsf)));
Rggsf=N*abs(Rggsf);
Rggsf=Rggsf/max(Rggsf);
Gbocsfl=10*log10(Gbocsf);             %Transformacion logaritmica dBW

L1CP=(10/11)*Gbocs+(1/11)*Gbocsf;         %MBOC(6,1,1/11)
L1CPl=10*log10(L1CP);

%************************************Suma de L1Cp(t) y L1Cd(t)
%L1C
%Generacion del mensaje
vinfo=ones(fsamp/250,1);
men=kron(cd,vinfo);
d=men(:); 
longd=length(d);
longi=length(cd);
a=fsamp/250;
b=(a*longi)-longd;
if (longd~=(a*longi))
    last=d(end);
    rest=last*ones(b,1);
    d=[d;rest];
end
signalL1C=d'.*Gbocs;
signalL1C=signalL1C.*L1CP;
%************************************Stadistics of a BOCsin(m,n) BOC(fs,fc)
%BOC(m,n)
% m=10;
% n=1;
% n1sg=sin((pi*f)/(2*m*fs));
% n2sg=sin((pi*f)/(n*fc));
% q1sg=pi*f;
% q2sg=cos((pi*f)/(2*m*fs));
% nsg=n1sg.*n2sg;
% qsg=q1sg.*q2sg;
% fractsg=nsg./qsg;
% Gbocsg=fc*((fractsg).^2);
% Rggsg=ifftshift(ifft(ifftshift(Gbocsf)));
% Rggsg=N*abs(Rggsf);
% Rggsg=Rggsf/max(Rggsf);
figure(1);
hold on
plot(f,Gbocs,'color','r');
plot(f,Gbocsf,'color','g');
plot(f,L1CP,'color','b');
%plot(f,Gbocsg,'color','c');        % BOC(m,n)
xlim([-20e6 20e6]);
legend('BOC(1,1)','BOC(6,1)','MBOC(6,1,1/11)','Location','NorthEast');
%legend('BOC(1,1)','MBOC(6,1,1/11)','Location','NorthEast');
xlabel('Hertzs');
ylabel('Power Spectral Density (W/ Hz)');
title('Power Spectral density (PSD) Seno');
grid on;
hold off

figure(2);
hold on
plot(f,Gbocsl,'color','r');
plot(f,Gbocsfl,'color','g');
plot(f,L1CPl,'color','b','linewidth',2);
xlim([-20e6 20e6]);
ylim([-100 -60]);
legend('BOC(1,1)','BOC(6,1)','MBOC(6,1,1/11)','Location','NorthEast');
txt = {'Ancho de banda BOC(1,1):' num2str(ABBOC11) 'Hz'}; text(-2e6,-95,txt,'Color','black','FontSize',12)
xlabel('Hertzs');
ylabel('Power Spectral Density (dBW/ Hz)');
title('Power Spectral density (PSD) Seno');
grid on;
hold off;

% figure(3);
% plot(f,signalL1C,'color','b');
%  xlim([-2e6 2e6]);
% % ylim([-2500 -10]);
% legend('SignalL1C','Location','NorthEast');
% xlabel('Hertzs');
% ylabel('Power Spectral Density (W/ Hz)');
% title('Power Spectral density (PSD) Seno');
% grid on;
% hold off;
