close all; clc;
%Compares Power Spectral density (PSD) and Autocorrelacion (ACF) of different BOC(fs,fc) modulations.
fo=1.023e6;
fsamp=120*fo;                       %Frecuencia de muestreo
B=5
Rb=250;
D=B/Rb;
N=fsamp*D;
k=-(N-1)/2:(N-1)/2;
df=fsamp/N;
f=k*df;
%*************************************Stadistics of a BOCsin(1,1)
n1s=sin((pi*f)/(2*fo));
n2s=sin((pi*f)/(fo));
q1s=pi*f;
q2s=cos((pi*f)/(2*fo));
ns=n1s.*n2s;
qs=q1s.*q2s;
fracts=ns./qs;
Gbocs=fo*(fracts).^2;
Rggs=ifftshift(ifft(ifftshift(Gbocs)));
Rggs=N*abs(Rggs);
Rggs=Rggs/max(Rggs);

%************************************Stadistics of a BOCsin(6,1)
n1sf=sin((pi*f)/(2*6*fo));
n2sf=sin((pi*f)/(fo));
q1sf=pi*f;
q2sf=cos((pi*f)/(2*6*fo));
nsf=n1sf.*n2sf;
qsf=q1sf.*q2sf;
fractsf=nsf./qsf;
Gbocsf=fo*((fractsf).^2);
Rggsf=ifftshift(ifft(ifftshift(Gbocsf)));
Rggsf=N*abs(Rggsf);
Rggsf=Rggsf/max(Rggsf);

%**************************************Stadistics of a BOCsin(10,5)
n10s=sin((pi*f)/(2*10*fo));
n20s=sin((pi*f)/(5*fo));
q10s=pi*f;
q20s=cos((pi*f)/(2*10*fo));
ns0=n10s.*n20s;
qs0=q10s.*q20s;
fracts0=ns0./qs0;
Gbocs0=5*fo*((fracts0).^2);
Rggs0=ifftshift(ifft(ifftshift(Gbocs0)));
Rggs0=N*abs(Rggs0);
Rggs0=Rggs0/max(Rggs0);
%*************************************Stadistics of a BOCsin(15,2.5)
n10z=sin((pi*f)/(2*15*fo));
n20z=sin((pi*f)/(2.5*fo));
q10z=pi*f;
q20z=cos((pi*f)/(2*15*fo));
ns0z=n10z.*n20z;
qs0z=q10z.*q20z;
fracts0z=ns0z./qs0z;
Gbocs0z=2.5*fo*((fracts0z).^2);
Rggs0z=ifftshift(ifft(ifftshift(Gbocs0z)));
Rggs0z=N*abs(Rggs0z);
Rggs0z=Rggs0z/max(Rggs0z);
%*************************************Stadistics of a BOCsin(15,10)
n10d=sin((pi*f)/(2*15*fo));
n20d=sin((pi*f)/(10*fo));
q10d=pi*f;
q20d=cos((pi*f)/(2*15*fo));
ns0d=n10d.*n20d;
qs0d=q10d.*q20d;
fracts0d=ns0d./qs0d;
Gbocs0d=10*fo*((fracts0d).^2);
Rggs0d=ifftshift(ifft(ifftshift(Gbocs0d)));
Rggs0d=N*abs(Rggs0d);
Rggs0d=Rggs0z/max(Rggs0d);

%*************************************Stadistics of a BOCcos(1,1)
%the only different thing is the first factor in the numerator
n1=(sin((pi*f)/(4*fo))).^2;
n=2*n1.*n2s;
fract=n./qs;
Gbocc=fo*(fract).^2;
Rggc=ifftshift(ifft(ifftshift(Gbocc)));
Rggc=N*abs(Rggc);
Rggc=Rggc/max(Rggc);

%*************************************Stadistics of a BOCcos(6,1)
n1i=(sin((pi*f)/(4*6*fo))).^2;
ni=2*n1i.*n2sf;
fracti=ni./qsf;
Gbocci=fo*(fracti).^2;
Rggci=ifftshift(ifft(ifftshift(Gbocci)));
Rggci=N*abs(Rggci);
Rggci=Rggc/max(Rggci);
%*************************************Stadistics of a BOCcos(10,5)
%the only different thing is the first factor in the numerator
n10=(sin((pi*f)/(4*10*fo))).^2;
n0=2*n10.*n20s;
fract0=n0./qs0;
Gbocc0=5*fo*((fract0).^2);
Rggc0=ifftshift(ifft(ifftshift(Gbocc0)));
Rggc0=N*abs(Rggc0);
Rggc0=Rggc0/max(Rggc0);
%**************************************Stadistics of a BOCcos(15,2.5)
n10z=(sin((pi*f)/(4*15*fo))).^2;
n0z=2*n10z.*n20z;
fract0z=n0z./qs0z;
Gbocc0z=2.5*fo*((fract0z).^2);
Rggc0z=ifftshift(ifft(ifftshift(Gbocc0z)));
Rggc0z=N*abs(Rggc0z);
Rggc0z=Rggc0z/max(Rggc0z);
%**************************************Stadistics of a BOCcos(15,10)
n10d=(sin((pi*f)/(4*15*fo))).^2;
n0d=2*n10d.*n20d;
fract0dd=n0d./qs0d;
Gbocc0dd=10*fo*((fract0dd).^2);
Rggc0dd=ifftshift(ifft(ifftshift(Gbocc0dd)));
Rggc0dd=N*abs(Rggc0dd);
Rggc0dd=Rggc0dd/max(Rggc0dd);

%___________________________________PLOTS_______________________________________
figure(1);
hold on
plot(f,Gbocs,'color','r');
plot(f,Gbocsf);
plot(f,Gbocs0,'color','g');
plot(f,Gbocs0z,'color','k');
xlim([-40e6 40e6]);
%legend('BOC(1,1)','BOC(6,1)','BOC(10,5)','BOC(15,2.5)',4,'Location','NorthEast');
legend('BOC(1,1)','BOC(6,1)','BOC(10,5)','BOC(15,2.5)','Location','NorthEast');
xlabel('Hertzs');
title('PSD Sine');
hold off
figure(2);
hold on
plot(f,Gbocc,'color','y');
plot(f,Gbocci,'color','c');
plot(f,Gbocc0,'color','m');
plot(f,Gbocc0z,'color','r');
xlim([-40e6 40e6]);
%legend('BOCcos(1,1)','BOCcos(6,1)','BOCcos(10,5)','BOCcos(15,2.5)',4,'Location','NorthEast');
legend('BOCcos(1,1)','BOCcos(6,1)','BOCcos(10,5)','BOCcos(15,2.5)','Location','NorthEast');
xlabel('Hertzs');
title('PSD Cosine');
hold off
figure(3);
hold on
plot(f,Gbocs0d,'Marker','d');
plot(f,Gbocc0dd,'color','r');
xlim([15.3445e6 15.346e6]);
%legend('BOC(15,10)','BOCcos(15,10)',2,'Location','northeast');
legend('BOC(15,10)','BOCcos(15,10)','Location','northeast');
hold off
figure(4);
hold on
plot(f,Gbocs,'color','c');
plot(f,Gbocsf);
plot(f,Gbocs0,'color','g');
plot(f,Gbocs0z,'color','k');
plot(f,Gbocc,'color','y');
plot(f,Gbocci,'color','r');
plot(f,Gbocc0,'color','m');
plot(f,Gbocc0z,'color','r');
%legend('BOC(1,1)','BOC(6,1)','BOC(10,5)','BOC(15,2.5)','BOCcos(1,1)','BOCcos(6,1)','BOCcos(10,5)','BOCcos(15,2.5)',8,'Location','NorthEast');
legend('BOC(1,1)','BOC(6,1)','BOC(10,5)','BOC(15,2.5)','BOCcos(1,1)','BOCcos(6,1)','BOCcos(10,5)','BOCcos(15,2.5)','Location','NorthEast');
xlim([-40e6 40e6]);
xlabel('Hertzs');
title('PSD Sine & Cosine');
hold off
