% Los requisitos especificados en IS-GPS-800F deben pertenecer a la seal 
% contenida dentro de un ancho de banda de 30,69 MHz centrado sobre 
% la frecuencia nominal L1.
ABTotal= 30.69e6;       %Ancho de banda L1C especificado en IS-GPS-800F
fc=1.023e6;             %Frecuencia de chip fc=nx1.023
fs=1.023e6;             %Frecuencia de subportadora fs=mx1.023
fsamp=120*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
k=-(N-1)/2:(N-1)/2;
df=fsamp/N;
%f=k*df;
frec_ABTotal=-(ABTotal/2):10:(ABTotal/2);        % Limites de integracion, Ancho de Banda
f=frec_ABTotal;
cd=[1 -1 -1 1 -1];      %Secuencia de datos
%******** BOC(6,1) *********
m=6;
n=1;
%phi61=2*(m/n);                    %is defined as two times the ratio between the sub-carrier and the chip frequency
n161=sin((pi*f)/(2*m*fs));
n261=sin((pi*f)/(n*fc));
q161=pi*f;
q261=cos((pi*f)/(2*m*fs));
n61=n161.*n261;
q61=q161.*q261;
fract61=n61./q61;
boc61=fc*((fract61).^2);
Ton61=1/(2*m*fc);                             %Tiempo en ON de la seal BOC(6,1) con m=6
%frec_ABTotal=-(ABTotal/2):1:(ABTotal/2);    % Limites de integracion, Ancho de Banda
S61=Ton61*sinc(frec_ABTotal*Ton61);         %S(f):Transformada de Fourier pulso rect
ABTotal_Num61=sum(((2*pi*frec_ABTotal).^2).*(abs(S61).^2)); 
ABTotal_Den61=sum(abs(S61).^2);
Bms_BOC61 = ABTotal_Num61/ABTotal_Den61;       %AB RMS (Hz^2)
%boc61l=10*log10(boc61);
%******** BOC(1,1) *********
m=1;
n=1;
%phi11=2*(m/n);                    %is defined as two times the ratio between the sub-carrier and the chip frequency
n111=sin((pi*f)/(2*m*fs));
n211=sin((pi*f)/(n*fc));
q111=pi*f;
q211=cos((pi*f)/(2*m*fs));
n11=n111.*n211;
q11=q111.*q211;
fract11=n11./q11;
boc11=fc*((fract11).^2);
Ton11=1/(2*m*fc);                 %Tiempo en ON de la seal BOC(1,1) con m=1
%boc11l=10*log10(boc11);
%**** MBOC(6,1,1/11)
L1Cp=(10/11)*boc11+(1/11)*boc61;
[ind] = find(isnan(L1Cp));
L1Cp(ind)=L1Cp(ind-1);
L1Cpl=10*log10(L1Cp);
%Clculo del ancho de banda cuadratico medio de la BOC(6,1)        
S11=Ton11*sinc(frec_ABTotal*Ton11);         %S(f):Transformada de Fourier pulso rect
ABTotal_Num11=sum(((2*pi*frec_ABTotal).^2).*(abs(S11).^2)); 
ABTotal_Den11=sum(abs(S11).^2);
Bms_BOC11 = ABTotal_Num11/ABTotal_Den11;    %AB RMS (Hz^2)
%**** Clculo del ancho de banda cuadratico medio 
TF_L1Cpilot = L1Cp;
ABTotal_Num_L1Cpilot=sum(((2*pi*frec_ABTotal).^2).*(abs(TF_L1Cpilot).^2),'omitnan'); 
ABTotal_Den_L1Cpilot=sum(abs(TF_L1Cpilot).^2,'omitnan');
Bms_L1Cpilot = ABTotal_Num_L1Cpilot/ABTotal_Den_L1Cpilot;    %AB RMS (Hz^2) 
BW_L1Cpilot = sqrt(Bms_L1Cpilot);                            %AB RMS (Hz)

% ACF=ifftshift(ifft(ifftshift(L1Cp)));
% ACF=N*abs(ACF);
% ACF=ACF/max(ACF);
% plot(f,ACF)
% xlim([-500 500]);
% ylim([min(ACF)-0.5 max(ACF)*1.2]);

%PL1CDmin=5.01187e-17;      %-163
PL1CPmin=3.98107e-16;       %-154
Esmin=(1/(fc))*PL1CPmin;
Ta=290;
kb=1.38064e-23;
No=kb*Ta;                   %-203.9752
VarCRL1CP=1/((203.9752-157)*(BW_L1Cpilot^2));
Precision_Distancia_L1C=sqrt(VarCRL1CP)*3e8; %Precisin en la medida de distancia (m).

if flaglineal==1
    %%%%%%%%%%%%%%%%% Representacion PSD lineal %%%%%%%%%%%%%%%%%%
    %axes(handles.AB);
    cla;
    set(handles.text2,'string','Valor medio:')
    hold on;
    [pks, locs]=findpeaks(L1Cp,f,'MinPeakProminence',(max(L1Cp)-max(L1Cp)/2)); %,'Annotate','extents'
    AverageDistance_Peaks = mean(diff(locs));
    plot(f/1e6,L1Cp,'color','b','LineWidth',2);
    xlim([-(ABTotal/(2e6)) (ABTotal/(2e6))]);
    ylim([-min(L1Cp)*1.1 max(pks)*1.1]);
    y = ylim;
    x = xlim;
    line([-(BW_L1Cpilot/2e6) (BW_L1Cpilot/2e6)],[max(pks) max(pks)],'LineWidth',2);
    line([-(BW_L1Cpilot/2e6) -(BW_L1Cpilot/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([(BW_L1Cpilot/2e6) (BW_L1Cpilot/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([x(1) x(2)],[max(pks)/2 max(pks)/2],'Color','black','LineStyle','--');
    %legend(['Signal', 'Anco de Banda RMS' ],'Location','NorthEast');
    legend off;
    xlabel('Frequency (MHz)');
    ylabel('Power Spectral Density (W/ Hz)');
    title('Power Spectral density (PSD) & Bandwidth');
    meanvalue=max(pks)/2;
    grid on;
    hold off;
elseif flaglineal==0
    %%%%%%%%%%%% Representacion PSD logaritmica %%%%%%%%
    cla;
    set(handles.text2,'string','Valor a -3 dB')
    hold on;
    [pks, locs]=findpeaks(L1Cpl,f,'MinPeakProminence',90); %,'Annotate','extents'
    AverageDistance_Peaks = mean(diff(locs));
    %[W,INITCROSS,FINALCROSS,MIDLEV]=pulsewidth(L1Cpl, f, 'Polarity', 'Positive','MidPercentReferenceLevel',97);
    plot(f/1e6,L1Cpl,'color','b','LineWidth',2);
    xlim([-(ABTotal/2e6) (ABTotal/2e6)]);
    ylim([-100 -60]);
    x = xlim;
    y = ylim;
    line([-(BW_L1Cpilot/2e6) (BW_L1Cpilot/2e6)],[max(pks) max(pks)],'LineWidth',2);
    line([-(BW_L1Cpilot/2e6) -(BW_L1Cpilot/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([(BW_L1Cpilot/2e6) (BW_L1Cpilot/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([x(1) x(2)],[max(pks)-3 max(pks)-3],'Color','black','LineStyle','--');
    legend off;
    xlabel('Frequency (MHz)');
    ylabel('Power Spectral Density (dBW/ Hz)');
    %title('Power Spectral density (PSD) & Bandwidth');
    meanvalue=max(pks)-3;
    grid on;
    hold off;
end
