%==========================================================================
% BPSK of chipping rate fc.
%--------------------------------------------------------------------------
%function S = BPSK(fc,F)
F = linspace(-50e6,50e6,1001);
ABTotal= 30.69e6;       %Ancho de banda L2C especificado en IS-GPS-200J
frec_ABTotal=-(ABTotal/2):10:(ABTotal/2);        % Limites de integracion, Ancho de Banda
fc= 1.023e6;
fs= 1.023e6;
S = sinc((1/fc)*frec_ABTotal); 
aux = sum(abs(S).^2)/length(S); 
S = S/sqrt(aux);
S_L2 = abs(S).^2;

%function BOCs(n,m,F)
m=1;
n=1;
fs = n*1.023e6;
fc = m*1.023e6;

S_BOC = sinc((1/fc)*frec_ABTotal).*tan(pi*frec_ABTotal/(2*fs));     
aux = sum(abs(S_BOC).^2)/length(S_BOC);
S_BOC = S_BOC/sqrt(aux);
S_BOC = abs(S_BOC).^2;

figure(1);
hold on;
plot(frec_ABTotal/1e6,10*log10(S_L2));
plot(frec_ABTotal/1e6,10*log10(S_BOC));
title('L2C spectrum')
ylabel('PSD (dBW/Hz)');
xlabel('Frequency (MHz)');
legend('L2C')
grid on;
ylim([-30 30])
hold off;

%Compares Power Spectral density (PSD) of different BOC(fs,fc) modulations.
fc=1.023e6;             %Frecuencia de chip fc=n?1.023
fs=1.023e6;             %Frecuencia de subportadora fs=m?1.023
% m=1;
% n=1;
phi=2*(m/n);            %is defined as two times the ratio between the sub-carrier and the chip frequency
fsamp=120*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
k=-(N-1)/2:(N-1)/2;
df=fsamp/N;
f=k*df;
cd=[1 -1 -1 1 -1];      %Secuencia de datos
%*************************************Stadistics of a BOCsin(1,1)
%Usamos la expresion o formula ideal para el calculo de BOCsin(fs,fc)
n1s=sin((pi*f)/(2*fc));         %Primer elemento num
n2s=sin((pi*f)/(fc));           %Segundo elemento num
q1s=pi*f;                       %Primer elemento den
q2s=cos((pi*f)/(2*fc));         %Segundo elemento den
ns=n1s.*n2s;                    %Numerador completo
qs=q1s.*q2s;                    %Denominador completo
fracts=ns./qs;
Gbocs=fc*(fracts).^2;

aux = sum(abs(Gbocs).^2)/length(Gbocs);
Gbocs = Gbocs/sqrt(aux);
Gbocs = abs(Gbocs).^2;
Gbocsl=10*log10(Gbocs);           %Transformacion logaritmica dBW


figure(2);
hold on
plot(f,Gbocsl,'color','r');
xlim([-20e6 20e6]);
ylim([-30 50]);
legend('BOC(1,1)','Location','NorthEast');
xlabel('Hertzs');
ylabel('Power Spectral Density (dB W/ Hz)');
title('Power Spectral density (PSD) Seno');
grid on;
hold off;
%end