function varargout = FA(varargin)
% FA M-file for FA.fig
%      FA, by itself, creates a new FA or raises the existing
%      singleton*.
%
%      H = FA returns the handle to a new FA or the handle to
%      the existing singleton*.
%
%      FA('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FA.M with the given input arguments.
%
%      FA('Property','Value',...) creates a new FA or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FA_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FA_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FA

% Last Modified by GUIDE v2.5 10-Jan-2020 20:59:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FA_OpeningFcn, ...
                   'gui_OutputFcn',  @FA_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FA is made visible.
function FA_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FA (see VARARGIN)

% Choose default command line output for FA
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FA wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FA_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;


% --- Executes on button press in representar.
function representar_Callback(hObject, eventdata, handles)
axes(handles.grafica);

h_f_fasis  = findobj(gcbf, 'Tag', 'fix_fasis');
h_f_modis  = findobj(gcbf, 'Tag', 'fix_modis');

h_amplis = findobj(gcbf, 'Tag', 'amplitudes');

amplitudesGruesas  = str2num(get(h_amplis, 'String'));

Nor  = length(amplitudesGruesas);

h_fasis = findobj(gcbf, 'Tag', 'fases');

if get(h_f_fasis, 'Value') == 1

   fasesGruesas = str2num(get(h_fasis, 'String'));
else
   fasesGruesas = zeros(1, length(amplitudesGruesas));
end

% Si modulamos en frecuencia, la "nueva" fase de cada muestra depende de los
% valores de la modulación

h_modis = findobj(gcbf, 'Tag', 'mod_frec');
new_fase = fasesGruesas;

if get(h_f_modis, 'Value') == 1

    mod_frec = str2num(get(h_modis, 'String'));
else
    mod_frec = zeros(1, length(amplitudesGruesas));
end

new_fase = new_fase + 2 * pi * cumsum(mod_frec);
expos = exp(1i*pi*new_fase);
sGruesa = amplitudesGruesas.* expos;
                                      
h1 = findobj(gcbf, 'Tag', 'res_senal');
r  = str2num(get(h1, 'String'));

% Tema CRUCIAL: aproximar las curvas
% De momento escalonamos los puntos intermedios. 

% El número total de muestras o divisiones en el tiempo N no puede ser un 
% valor cualquiera. Depende de r y No. Tampoco puedo asignar un
% valora arbitrario a las divisiones si quiero respetar el número de 
% muestras finales respecto a las originales.

divisiones = floor((r*(Nor-1) + Nor)/Nor);
N = Nor * divisiones;

% Replicamos cada muestra original (divisiones - 1 veces)

s = [];

for z = 1 : Nor
    s=[s sGruesa(z)];
    for zz = 1 : divisiones-1
        s =[s sGruesa(z)];
    end
end

h_dur_senal = findobj(gcbf, 'Tag', 'dur_senal');
dur_senal = str2num(get(h_dur_senal, 'String'));

h1 = findobj(gcbf, 'Tag', 'res_frec');
num_f  = str2num(get(h1, 'String'));

h1 = findobj(gcbf, 'Tag', 'frec_max');
flimite  = str2num(get(h1, 'String'));

h1 = findobj(gcbf, 'Tag', 'pos_neg');
neg = get(h1, 'value');

h1=findobj(gcbf, 'Tag', 'tresd_contour');
tresd = get(h1, 'value');

% ... y llamamos a la función que dibuja
axes(handles.grafica);
representa_fa ;
axes(handles.axes5);
plot(f , corte_tau_cero,  'LineWidth', 1, 'Color', [0 0 1]);
grid on;
xlabel('Frequency Doppler (MHz)');
ylabel('Power Spectral Density (W/ Hz)');

axes(handles.axes6);
plot(tau, autocorrelacion,  'LineWidth', 1, 'Color', [1 0 0]);
grid on;
xlabel('Retardo en us');
[pks, locs]=findpeaks(autocorrelacion);
AverageDistance_Peaks = mean(diff(locs));
[maximo1, posicion1]=max(pks);
pks=pks(posicion1:end);
pks(1)=-inf;
[maximo2, posicion2]=max(pks);
pks(posicion2)=-inf;
[maximo3, posicion3]=max(pks);
pks(posicion3)=-inf;
[maximo4, posicion4]=max(pks);
pks(posicion4)=-inf;
[maximo5, posicion5]=max(pks);
pks(posicion5)=-inf;
if maximo2==-inf
    maximo2=0;
    maximo3=0;
    maximo4=0;
    maximo5=0;
elseif maximo3==-inf
    maximo3=0;
    maximo4=0;
    maximo5=0;
elseif maximo4==-inf
    maximo4=0;
    maximo5=0;
elseif maximo5==-inf
    maximo5=0;
end

%ylabel('Retardo en us');

set(handles.edit15,'String',maximo1);
set(handles.edit16,'String',maximo2);
set(handles.edit17,'String',maximo3);
set(handles.edit18,'String',maximo4);
set(handles.edit19,'String',maximo5);
set(handles.edit20,'String',maximo1/maximo2);
set(handles.edit22,'String',maximo1/maximo3);
set(handles.edit21,'String',maximo1/maximo4);
set(handles.edit23,'String',maximo1/maximo5);

function amplitudes_Callback(hObject, eventdata, handles)

% Cuando el usuario modifica la señal, se cambia el nombre en GUI

% Si tocamos aqui hay que actualizar n y modificar el nombre de la señal
calculo_de_n

nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');
set(nombre_senal, 'String', 'Señal usuario')

% --- Executes during object creation, after setting all properties.
function amplitudes_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function fases_Callback(hObject, eventdata, handles)

% Si tocamos aqui hay que actualizar n y modificar el nombre de la señal
calculo_de_n

nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');
set(nombre_senal, 'String', 'Señal usuario')


% --- Executes during object creation, after setting all properties.
function fases_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function res_senal_Callback(hObject, eventdata, handles)

% Si tocamos aqui hay que actualizar n
calculo_de_n

% --- Executes during object creation, after setting all properties.
function res_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function res_frec_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function res_frec_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function frec_max_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function frec_max_Callback(hObject, eventdata, handles)

% --- Executes on selection change in predefinidas.
function predefinidas_Callback(hObject, eventdata, handles)

val=get(hObject,'Value');
str=get(hObject,'String');

amplis       = findobj(gcbf, 'Tag', 'amplitudes');  % Vector de amplitudes
fasis        = findobj(gcbf, 'Tag', 'fases');       % Vector de las fases
modis        = findobj(gcbf, 'Tag', 'mod_frec');    % Vector de modulacion en frecuencia
nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');% Nombre de la señal
res_senal    = findobj(gcbf, 'Tag', 'res_senal');   % En cuanto queremos dividir cada muestra
res_frec     = findobj(gcbf, 'Tag', 'res_frec');    % Cuantas divisiones de frecuencias queremos usr
frec_max     = findobj(gcbf, 'Tag', 'frec_max');    % Frec. máxima. A partir de 0.5 se repite. Investigar

h_f_fasis  = findobj(gcbf, 'Tag', 'fix_fasis');
h_f_modis  = findobj(gcbf, 'Tag', 'fix_modis');

h_pos_neg  = findobj(gcbf, 'tag', 'pos_neg');
axes(handles.axes2);
switch str{val}
    
    case 'L1C' 
        
       % Aquí hago los settings y actualizo los cajetines
       % Cuando añadimos uno nuevo no olvidar de actualizar el desplegable
       % del GUI.
       set(handles.axes2,'Visible','on');
       L1C_gen();
       %y= num2str(round(L1Csen,2));
       L1=num2str(round(L1Csen,1));
       L1=strrep(L1,'        ',' ');
       L1=strrep(L1,'       ',' ');
       set(amplis, 'String', L1, 'FontSize', 6.45)
%         set(fasis,  'String', '0 0 0 0 0')
%         set(modis,  'String', '0 0 0 0 0')
        
%         set(h_f_fasis,  'Value', 0)
%         set(h_f_modis,  'Value', 0)
        
        set(h_pos_neg,  'Value', 1)
        
        set(nombre_senal, 'String', 'L1C')
        set(res_senal,    'String', '15')
        set(res_frec,     'String', '80')
        set(frec_max,     'String', '0.5')
        
        calculo_de_n
%         
%         apagar_BOC
%         encender_cajetines
        
    case 'L2C' 
        set(handles.axes2,'Visible','on');
        set(handles.axes2,'Visible','on');
       L2C_gen();
       %y= num2str(round(L1Csen,2));
       L1=num2str(round(L2Csen,1));
       L1=strrep(L1,'        ',' ');
       L1=strrep(L1,'       ',' ');
       set(amplis, 'String', L1, 'FontSize', 11)
%         set(amplis, 'String', '1 0 1 0 1 0 1 0 1 0') 
%         set(fasis,  'String', '0 0 0 0 0 0 0 0 0 0')
%         set(modis,  'String', '0 0 0 0 0 0 0 0 0 0')
% 
%         set(h_f_fasis,  'Value', 0)
%         set(h_f_modis,  'Value', 0)
        
        set(h_pos_neg,  'Value', 1)
        
        set(nombre_senal, 'String', 'L2C')
        set(res_senal,    'String', '72')
        set(res_frec,     'String', '80')
        set(frec_max,     'String', '0.5')
        
        calculo_de_n
        
%         apagar_BOC
%         encender_cajetines
        
    case 'L5' % Típico codificado en fase
        set(handles.axes2,'Visible','on');
        set(handles.axes2,'Visible','on');
       L5_gen();
       %y= num2str(round(L1Csen,2));
       L1=num2str(round(L5sen,1));
       L1=strrep(L1,'        ',' ');
       L1=strrep(L1,'       ',' ');
       set(amplis, 'String', L1, 'FontSize', 11)
%         set(amplis, 'String', '1 1 1 1 1 1 1 1 1 1 1 1 1') 
%         set(fasis,  'String', '1 1 1 1 1 0 0 1 1 0 1 0 1')
%         set(modis,  'String', '0 0 0 0 0 0 0 0 0 0 0 0 0')
% 
%         set(h_f_fasis,  'Value', 1)
%         set(h_f_modis,  'Value', 0)
        
        set(h_pos_neg,  'Value', 1)
        
        set(nombre_senal, 'String', 'L5')
        set(res_senal,    'String', '72')
        set(res_frec,     'String', '80')
        set(frec_max,     'String', '0.5')   
        
        calculo_de_n
        
%         apagar_BOC
%         encender_cajetines
end    

% --- Executes during object creation, after setting all properties.
function predefinidas_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function grafica_CreateFcn(hObject, eventdata, handles)

function panel_FA_CreateFcn(hObject, eventdata, handles)

% --- Executes on button press in pos_neg.
function pos_neg_Callback(hObject, eventdata, handles)

function mod_frec_Callback(hObject, eventdata, handles)

calculo_de_n

nombre_senal = findobj(gcbf, 'Tag', 'nombre_senal');
set(nombre_senal, 'String', 'Señal usuario');

% --- Executes during object creation, after setting all properties.
function mod_frec_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in tresd_contour.
function tresd_contour_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function n_usadas_CreateFcn(hObject, eventdata, handles)

% --- Executes on button press in n_usadas.
function n_usadas_Callback(hObject, eventdata, handles)


function calculo_de_n()

amplis    = findobj(gcbf, 'Tag', 'amplitudes');       
res_senal = findobj(gcbf, 'Tag', 'res_senal');      % En cuanto queremos dividir cada muestra
n_usadas  = findobj(gcbf, 'Tag', 'n_usadas');

muestras  = length(str2num(get(amplis, 'String')));

res  = str2num(get(res_senal, 'String'));
divs = floor((res*(muestras-1) + muestras)/muestras);
n_u = muestras * divs;

set(n_usadas, 'String', n_u)

% --- Executes during object creation, after setting all properties.
function BOC_m_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function BOC_m_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function BOC_n_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function BOC_n_Callback(hObject, eventdata, handles)

% --- Executes on button press in calc_boc.
function calc_boc_Callback(hObject, eventdata, handles)

calcular_boc


% --- Executes during object creation, after setting all properties.
function dur_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function dur_senal_Callback(hObject, eventdata, handles)


% --- Executes on button press in fix_fasis.
function fix_fasis_Callback(hObject, eventdata, handles)


% --- Executes on button press in fix_modis.
function fix_modis_Callback(hObject, eventdata, handles)



function edit12_Callback(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit12 as text
%        str2double(get(hObject,'String')) returns contents of edit12 as a double


% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit13_Callback(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit13 as text
%        str2double(get(hObject,'String')) returns contents of edit13 as a double


% --- Executes during object creation, after setting all properties.
function edit13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit14_Callback(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit14 as text
%        str2double(get(hObject,'String')) returns contents of edit14 as a double


% --- Executes during object creation, after setting all properties.
function edit14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit15 as text
%        str2double(get(hObject,'String')) returns contents of edit15 as a double


% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit16_Callback(hObject, eventdata, handles)
% hObject    handle to edit16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit16 as text
%        str2double(get(hObject,'String')) returns contents of edit16 as a double


% --- Executes during object creation, after setting all properties.
function edit16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit17_Callback(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit17 as text
%        str2double(get(hObject,'String')) returns contents of edit17 as a double


% --- Executes during object creation, after setting all properties.
function edit17_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit18_Callback(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit18 as text
%        str2double(get(hObject,'String')) returns contents of edit18 as a double


% --- Executes during object creation, after setting all properties.
function edit18_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit19_Callback(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit19 as text
%        str2double(get(hObject,'String')) returns contents of edit19 as a double


% --- Executes during object creation, after setting all properties.
function edit19_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit19 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit20_Callback(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit20 as text
%        str2double(get(hObject,'String')) returns contents of edit20 as a double


% --- Executes during object creation, after setting all properties.
function edit20_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit21_Callback(hObject, eventdata, handles)
% hObject    handle to edit21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit21 as text
%        str2double(get(hObject,'String')) returns contents of edit21 as a double


% --- Executes during object creation, after setting all properties.
function edit21_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit21 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit22_Callback(hObject, eventdata, handles)
% hObject    handle to edit22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit22 as text
%        str2double(get(hObject,'String')) returns contents of edit22 as a double


% --- Executes during object creation, after setting all properties.
function edit22_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit23_Callback(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit23 as text
%        str2double(get(hObject,'String')) returns contents of edit23 as a double


% --- Executes during object creation, after setting all properties.
function edit23_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
