%==========================================================================
% L2C BPSK of chipping rate fc.
%--------------------------------------------------------------------------
ABTotal= 30.69e6;       %Ancho de banda L2C especificado en IS-GPS-200J
frec_ABTotal=-(ABTotal/2):10:(ABTotal/2);        % Limites de integracion, Ancho de Banda
fc= 1.023e6;
fs= 1.023e6;
fsamp=120*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
TonL2C=1/1.023e6;
f=frec_ABTotal;
S = sinc((1/fc)*frec_ABTotal); 
aux = sum(abs(S).^2)/length(S); 
S = S/sqrt(aux);
S_L2C = abs(S).^2;
S_L2Cl=10*log10(S_L2C);

% S2 = (1/fc)*(sinc(frec_ABTotal/fc));
% S1_L2C = abs(S).^2;
%TF_L1Cpilot = L1Cp;
ABTotal_Num_L2C=sum(((2*pi*frec_ABTotal).^2).*(abs(S_L2C).^2),'omitnan'); 
ABTotal_Den_L2C=sum(abs(S_L2C).^2,'omitnan');
Bms_L2C = ABTotal_Num_L2C/ABTotal_Den_L2C;    %AB RMS (Hz^2) 
BW_L2C = sqrt(Bms_L2C);                            %AB RMS (Hz)  

PL2Cmin=5.011872e-16;           %-153
Esmin=TonL2C*PL2Cmin;
Ta=290;
kb=1.38064e-23;
No=kb*Ta;
VarCRL2C=1/((203.9752-160)*(BW_L2C^2));
Precision_Distancia_L2C=sqrt(VarCRL2C)*3e8; %Precisin en la medida de distancia (m).  

if flaglineal==1
    %%%%%%%%%%%%%%%%% Representacion PSD lineal %%%%%%%%%%%%%%%%%%
    %axes(handles.AB2);
    cla;
    set(handles.text8,'string','Valor medio: ')
    hold on;
    plot(frec_ABTotal/1e6,S_L2C,'color','g','LineWidth',2);
    [pks, locs]=findpeaks(S_L2C,f,'MinPeakProminence',(max(S_L2C)-max(S_L2C)/2)); %,'Annotate','extents'
    AverageDistance_Peaks = mean(diff(locs));
    xlim([-(ABTotal/(2e6)) (ABTotal/(2e6))]);
    ylim([-min(S_L2C)*1.2 max(pks)*1.2]);
    y = ylim;
    x = xlim;
    line([-(BW_L2C/2e6) (BW_L2C/2e6)],[max(pks) max(pks)],'LineWidth',2);
    line([-(BW_L2C/2e6) -(BW_L2C/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([(BW_L2C/2e6) (BW_L2C/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([x(1) x(2)],[max(pks)/2 max(pks)/2],'Color','black','LineStyle','--');
    ylabel('Power Spectral Density (BW/Hz)');
    xlabel('Frequency (MHz)');
    meanvalue=max(pks)/2;
    grid on;
    hold off;
elseif flaglineal==0
    %axes(handles.AB2);
    cla;
    hold on;
    plot(frec_ABTotal/1e6,S_L2Cl,'color','g','LineWidth',2);
    set(handles.text8,'string','Valor a -3 dB:')
    [pks, locs]=findpeaks(S_L2Cl,f,'MinPeakProminence',(max(S_L2Cl)-max(S_L2Cl)/2)); %,'Annotate','extents'
    AverageDistance_Peaks = mean(diff(locs));
    xlim([-(ABTotal/(2e6)) (ABTotal/(2e6))]);
    ylim([(max(S_L2Cl)-60) max(S_L2Cl)*1.2])
    y = ylim;
    x = xlim;
    line([-(BW_L2C/2e6) (BW_L2C/2e6)],[max(pks) max(pks)],'LineWidth',2);
    line([-(BW_L2C/2e6) -(BW_L2C/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([(BW_L2C/2e6) (BW_L2C/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([x(1) x(2)],[max(pks)-3 max(pks)-3],'Color','black','LineStyle','--');
    ylabel('Power Spectral Density (dBW/Hz)');
    xlabel('Frequency (MHz)');
    meanvalue=max(pks)-3;
    grid on;    
    hold off;
end