%==========================================================================
% L5 BPSK of chipping rate fc.
%--------------------------------------------------------------------------
ABTotal= 24e6;       %Ancho de banda L2C especificado en IS-GPS-200J
frec_ABTotal=-(ABTotal/2):10:(ABTotal/2);        % Limites de integracion, Ancho de Banda
fc= 10.023e6;
fs= 1.023e6;
fsamp=120*fc;
B=5;
Rb=250;
D=B/Rb;
N=fsamp*D;
TonL5=1/10.023e6;
f=frec_ABTotal;
S = sinc((1/fc)*frec_ABTotal); 
aux = sum(abs(S).^2)/length(S); 
S = S/sqrt(aux);
S_L5 = abs(S).^2;
S_L5l=10*log10(S_L5);

% S2 = (1/fc)*(sinc(frec_ABTotal/fc));
% S1_L2C = abs(S).^2;
%TF_L1Cpilot = L1Cp;
ABTotal_Num_L5=sum(((2*pi*frec_ABTotal).^2).*(abs(S_L5).^2),'omitnan'); 
ABTotal_Den_L5=sum(abs(S_L5).^2,'omitnan');
Bms_L5 = ABTotal_Num_L5/ABTotal_Den_L5;    %AB RMS (Hz^2) 
BW_L5 = sqrt(Bms_L5);                            %AB RMS (Hz)  

% ACF=ifftshift(ifft(ifftshift(S_L5)));
% ACF=N*abs(ACF);
% ACF=ACF/max(ACF);
% %Z = interp1((linspace(-1, 1, length(Z))), ACF, (linspace(-1, 1, r*length(Z)-1)));
% plot(f,ACF)
% xlim([-500 500]);
% ylim([min(ACF)-0.5 max(ACF)*1.2]);

PL5min=1e-15;       %150
Esmin=TonL5*PL5min;
Ta=290;
kb=1.38064e-23;
No=kb*Ta;
VarCRL5=1/((203.9752-157.9)*(BW_L5^2));
Precision_Distancia_L5=sqrt(VarCRL5)*3e8; %Precisin en la medida de distancia (m).  

if flaglineal==1
    %%%%%%%%%%%%%%%%% Representacion PSD lineal %%%%%%%%%%%%%%%%%%
    %axes(handles.AB2);
    cla;
    set(handles.text8,'string','Valor medio: ')
    hold on;
    plot(frec_ABTotal/1e6,S_L5,'color','m','LineWidth',2);
    [pks, locs]=findpeaks(S_L5,f,'MinPeakProminence',(max(S_L5)-max(S_L5)/2)); %,'Annotate','extents'
    AverageDistance_Peaks = mean(diff(locs));
    xlim([-(ABTotal/(2e6)) (ABTotal/(2e6))]);
    ylim([-min(S_L5)*2 max(pks)*1.5]);
    y = ylim;
    x = xlim;
    line([-(BW_L5/2) (BW_L5/2)],[max(pks) max(pks)],'LineWidth',2);
    line([-(BW_L5/2) -(BW_L5/2)],[y(1) max(pks)],'LineWidth',2);
    line([(BW_L5/2) (BW_L5/2)],[y(1) max(pks)],'LineWidth',2);
    line([x(1) x(2)],[max(pks)/2 max(pks)/2],'Color','black','LineStyle','--');
    ylabel('Power Spectral Density (BW/Hz)');
    xlabel('Frequency (MHz)');
    meanvalue=max(pks)/2;
    grid on;
    hold off;
elseif flaglineal==0
    %axes(handles.AB2);
    cla;
    hold on;
    plot(frec_ABTotal/1e6,S_L5l,'color','m','LineWidth',2);
    set(handles.text8,'string','Valor a -3 dB:')
    [pks, locs]=findpeaks(S_L5l,f,'MinPeakProminence',(max(S_L5l)-max(S_L5l)/2)); %,'Annotate','extents'
    AverageDistance_Peaks = mean(diff(locs));
    xlim([-(ABTotal/(2e6)) (ABTotal/(2e6))]);
    ylim([(max(S_L5l)-60) max(S_L5l)*2])
    y = ylim;
    x = xlim;
    line([-(BW_L5/2e6) (BW_L5/2e6)],[max(pks) max(pks)],'LineWidth',2);
    line([-(BW_L5/2e6) -(BW_L5/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([(BW_L5/2e6) (BW_L5/2e6)],[y(1) max(pks)],'LineWidth',2);
    line([x(1) x(2)],[max(pks)-3 max(pks)-3],'Color','black','LineStyle','--');
    ylabel('Power Spectral Density (dBW/Hz)');
    xlabel('Frequency (MHz)');
    meanvalue=max(pks)-3;
    grid on;    
    hold off;
end