function varargout = MP(varargin)
%MP M-file for MP.fig
%      MP, by itself, creates a new MP or raises the existing
%      singleton*.
%
%      H = MP returns the handle to a new MP or the handle to
%      the existing singleton*.
%
%      MP('Property','Value',...) creates a new MP using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to MP_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      MP('CALLBACK') and MP('CALLBACK',hObject,...) call the
%      local function named CALLBACK in MP.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MP

% Last Modified by GUIDE v2.5 25-May-2011 17:23:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MP_OpeningFcn, ...
                   'gui_OutputFcn',  @MP_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT

% --- Executes just before MP is made visible.
function MP_OpeningFcn(hObject, eventdata, handles, varargin)

%Creamos algunos datos para una señal sencilla

handles.current_data=ones(1,5);
  
h1 = findall(gcf, 'Tag', 'panel_temporal_senal');
h_temp = subplot('Position', [0.10 0.20 0.85 0.72], 'Parent', h1);

stem(h_temp, handles.current_data);
ylim(h_temp, [0 1.2])
xlim(h_temp, [0 6])
grid(h_temp, 'on')

% Choose default command line output for MP
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes MP wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = MP_OutputFcn(hObject, eventdata, handles)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in representar.
function representar_Callback(hObject, eventdata, handles)

% Tomemos los datos que nos hacen falta del GUI

% Lo que dura señal en tiempo. Normalmente us
h1 = findobj(gcbf, 'Tag', 'duracion_senal');
T  = str2num(get(h1, 'String'));

% Las muestras que tiene la señal en origen
h1 = findobj(gcbf, 'Tag', 'num_muestras');
Ts = str2num(get(h1, 'String'));

% Factor para hacer zero padding
h1 = findobj(gcbf, 'Tag', 'res_senal');
r  = str2num(get(h1, 'String'));

% Opciones de representación.
% Varias gráficas superpuestas
h1 = findobj(gcbf, 'Tag', 'fix');
fix   = get(h1, 'value');

% El color de la señal siempre que pulso Representar es magenta
% Cuando he pulsado 'color' será uno aleatorio
% Cuando he pulsado 'usar ' será el color definido

h1 = findobj(gcbf, 'Tag', 'color');
h2 = findobj(gcbf, 'Tag', 'color_senal');
h3 = findobj(gcbf, 'Tag', 'usar');

if get(h1, 'UserData') == 1
    set(h2, 'String', rand(1, 3))
    set(h1, 'UserData', num2str(0))
else
    if get(h3, 'UserData')  ~= 1
        set(h2, 'String', [1 0 1])
    else
        set(h3, 'UserData', num2str(0))
    end
end

% La señal
h1 = findobj(gcbf, 'Tag', 'amplitudes');
x  = str2num(get(h1, 'String'));

% ... y llamamos a la representación

autocorrelador();
mpath4();
check_signal();
representa3();

% --- Executes on selection change in desplegable_gnss.
function desplegable_gnss_Callback(hObject, eventdata, handles)


% Obtengamos los datos de señales predefinidas

% El primer color con el que dibujo es con magenta.
h1 = findobj(gcbf, 'Tag', 'color_senal');
set(h1, 'String', '1 0 1')

val=get(hObject,'Value');
str=get(hObject,'String');

default = 1;

switch str{val}
    
    case 'Pulso Rectangular' 
 
        pulse_generator;
         
    case 'BOC' 
        
        boc_generator;
    
    case 'SQRRC' 
        
        sqrrc_generator;
       
    case 'GPS-L1'
        
        gps_L1_generator;
        
    case 'CBOC Galileo E1'
           
        E1_generator;
    
    case 'CBOC'
           
        CBOC_generator;
end

function encender_sqrrc()
        
        h1=findobj(gcbf, 'Tag', 'panel_sqrrc');
        set(h1,  'Visible', 'on')
        
function apagar_sqrrc()
        
        h1=findobj(gcbf, 'Tag', 'panel_sqrrc');
        set(h1,  'Visible', 'off')
        
function encender_boc()

        h1=findobj(gcbf, 'Tag', 'panel_boc');
        set(h1,  'Visible', 'on')
                     
 function apagar_boc()
        
        h1=findobj(gcbf, 'Tag', 'panel_boc');
        set(h1,  'Visible', 'off')

function encender_cboc()
        
        h1=findobj(gcbf, 'Tag', 'panel_cboc');
        set(h1,  'Visible', 'on')
        
 function apagar_cboc()
        
        h1=findobj(gcbf, 'Tag', 'panel_cboc');
        set(h1,  'Visible', 'off')
        
        
% --- Executes during object creation, after setting all properties.
function desplegable_gnss_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function res_senal_Callback(hObject, eventdata, handles)
    jj = get(hObject,'String');
    
    if str2num(jj)/2 ~= ceil(str2num(jj)/2)
        set( hObject, 'String', num2str(round(str2num(jj))) )
    end

function res_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function BOC_m_Callback(hObject, eventdata, handles)
default = 0;
boc_generator;

function BOC_n_Callback(hObject, eventdata, handles)
default = 0;
boc_generator;

% --- Executes during object creation, after setting all properties.
function BOC_m_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function BOC_n_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% ---
function duracion_senal_Callback(hObject, eventdata, handles)
% Aunque toque aquí no hay cambio en el resto. El valor queda almacenado 

% --- Executes during object creation, after setting all properties.
function duracion_senal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% ---
function num_muestras_Callback(hObject, eventdata, handles)
default = 0;
pulse_generator;

% --- Executes during object creation, after setting all properties.
function num_muestras_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function representar_CreateFcn(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function panel_principal_CreateFcn(hObject, eventdata, handles)

function roll_off_Callback(hObject, eventdata, handles)
    % Parámetro exclusivo de SQRRC. Recalculamos y dibujamos
    default = 0;
    sqrrc_generator;
    

% --- Executes during object creation, after setting all properties.
function roll_off_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% ---
function ls_Callback(hObject, eventdata, handles)
    % Parámetro exclusivo de SQRRC. Recalculamos y dibujamos
    default = 0;
    sqrrc_generator; 
    
% --- Executes during object creation, after setting all properties.
function ls_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function nss_Callback(hObject, eventdata, handles)
    % Parámetro exclusivo de SQRRC. Recalculamos y dibujamos
    default = 0;
    sqrrc_generator;
    
% --- Executes on button press in fix.
function fix_Callback(hObject, eventdata, handles)    

    
% --- Executes on button press in clear.
function clear_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function nss_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function e_l_Callback(hObject, eventdata, handles)
   % No permitimos valores absurdos

    if str2num(get(hObject,'String')) < 0 
        set(hObject, 'String', num2str(0))
    end 
    if str2num(get(hObject,'String')) > 1 
        set(hObject, 'String', num2str(1))
    end 

% --- Executes during object creation, after setting all properties.
function e_l_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function fix_CreateFcn(hObject, eventdata, handles)

% --- Executes on button press in almacenar.
function almacenar_Callback(hObject, eventdata, handles)

store

% --- Executes on button press in usar.
function usar_Callback(hObject, eventdata, handles)
  
set(hObject, 'UserData', 1)
usar
representar_Callback()
    
% --- Executes on button press in senal_2.
function senal_2_Callback(hObject, eventdata, handle)

% --- Executes during object creation, after setting all properties.
function datos_senal_1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_1_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function datos_senal_2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_2_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function datos_senal_3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_3_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function datos_senal_4_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function datos_senal_4_Callback(hObject, eventdata, handles)

% --- Executes on button press in color.
function color_Callback(hObject, eventdata, handles)

% Levantamos la banderola que hemos pulsado 'color'

set(hObject, 'UserData', 1)
representar_Callback()

function cboc_m1_Callback(hObject, eventdata, handles)
    default = 0;
    CBOC_generator;

% --- Executes during object creation, after setting all properties.
function cboc_m1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function cboc_n1_Callback(hObject, eventdata, handles)
    default = 0;
    CBOC_generator;

% --- Executes during object creation, after setting all properties.
function cboc_n1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function p1_Callback(hObject, eventdata, handles)
    default = 0;
    CBOC_generator;

% --- Executes during object creation, after setting all properties.
function p1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function cboc_m2_Callback(hObject, eventdata, handles)
    default = 0;
    CBOC_generator;

% --- Executes during object creation, after setting all properties.
function cboc_m2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function cboc_n2_Callback(hObject, eventdata, handles)
    default = 0;
    CBOC_generator;

% --- Executes during object creation, after setting all properties.
function cboc_n2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function p2_Callback(hObject, eventdata, handles)
    default = 0;
    CBOC_generator;

% --- Executes during object creation, after setting all properties.
function p2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in cboc_mas_menos.
function cboc_mas_menos_Callback(hObject, eventdata, handles)
    default = 0;
    CBOC_generator;


function ampli_Mpath_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function ampli_Mpath_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
