%% Tomamos la autocorrelación Z
%

% Expresemos d en función de las muestras de Z
% 
% h_e_l = findobj(gcbf, 'Tag', 'e_l');
% d = str2num(get(h_e_l,  'String'));
% 
% h_ampli = findobj(gcbf, 'Tag', 'ampli_Mpath');
% ampli   = str2num(get(h_ampli, 'String'));

% d=0.1;
% ampli=0.5;
% Debemos hacer un redondeo. Es la sepración entre early y late en muestras
% de la correlación

centro = ceil(length(Z)/2);
d_muestras = floor((centro-1) * d/2);

% Definimos algunos vectores bien largos

late  = [Z zeros(1, 2*d_muestras)];
early = [zeros(1, 2*d_muestras) Z];

% La curva del discriminador para la señal y con apertura d
D = (early - late);

% La réplica multipath
D_low = D * ampli;

% Centro de ambas secuencias
centro = ceil(length(D)/2);

% El entorno en el que voy a buscar el cero crossing
delta_centro = ceil(d_muestras/2);

error_plus = [0];
error_min  = [0];

for k = 0 : floor(length(D_low)/2)+1

D_Mpath = [ zeros(1,k) D_low(1:end-k) ];

% Equivale a interferencia en fase (0º)
suma  = D + D_Mpath;

% Equivale a interferencia en antifase (180º)
resta = D - D_Mpath;
   
    % Veamos donde cruzan los resultados de las interferencias el eje x en
    % el entorno del centro. Es un "truco" que limita las posibilidades
    % pero simplifica los cálculos.
    
    S =  suma(centro-delta_centro : centro+delta_centro);
     
    aux = crossing(S);
    if length(aux) > 1
        previo = error_plus([k+1]);
        kk     = aux - ceil(length(S)/2);
        ind    = find(abs(kk - previo) == min(abs(kk - previo)));
        
        cruce_true = aux(ind);
        
    else
        
        cruce_true = crossing(S);
    end
    
    dato_suma = cruce_true - ceil(length(S)/2);
    
    S = resta(centro-delta_centro : centro+delta_centro);
    
    aux = crossing(S);
    if length(aux) > 1
        previo = error_min([k+1]);
        kk     = aux - ceil(length(S)/2);
        ind    = find(abs(kk - previo) == min(abs(kk - previo)));
        
        cruce_true = aux(ind);
        
    else
        cruce_true = crossing(S);
    end
    
    dato_resta = cruce_true - ceil(length(S)/2);
    
    error_plus = [error_plus dato_suma ];
    error_min  = [error_min  dato_resta]; 
    
end

D = error_plus;

maximo = max(D);

longi_D = length(D);

dur_chips_x = 1 + d/2;
dur_chips_y = max(D)*dur_chips_x/length(D);
%T=0.9775;

D = (dur_chips_y * D/maximo)*T*300;

error_min = (dur_chips_y * error_min/maximo)*T*300;

% Confinamos en un chip mas el porcentaje debido al ancho del correlador
% Usamos dos ejes por si hay "discrepancias" en las longitudes

eje_error = linspace(0, dur_chips_x*T*300, length(D));
eje_error_min = linspace(0, dur_chips_x*T*300, length(error_min));

