%% Representación gráfica de la autocorrelación y del multipath

% Definamos algunos puntos donde representar las gráficas
% Estos valores corresponden a la gráfica inferior. La superior se
% autoajusta
% izq   = 0.075    ; bajo  = 0.057;
% ancho = 0.90     ; alto  = 0.350;
% margen= 0.05     ;
% 
margen_auto = 0.1;

m_x_chip = 0.977517*300;

% if strcmp(signal,'L5')
%     m_x_chip = T*1000;
%     L5p=1;
% elseif L5p==0
%     m_x_chip = T*300;
% end

%h_color_senal = findobj(gcbf, 'Tag', 'color_senal');
color_linea = get(handles.color_senal,'string');


h_panel = findall(gcf, 'Tag', 'panel_grafica3');

% auto  = subplot('Position', [izq bajo+alto+margen ancho 1-1.5*margen-alto-bajo], 'Parent', h_panel);
% multi = subplot('Position', [izq bajo ancho alto], 'Parent', h_panel);

auto  = subplot('Position', [0.06 0.59 0.9 0.4], 'Parent', h_panel);
multi = subplot('Position', [0.06 0.057 0.9 0.47], 'Parent', h_panel);

set(auto,  'Tag', 'grafica_auto');
set(multi, 'Tag', 'grafica_multi');

h_auto  = findobj('Tag', 'grafica_auto' );
h_multi = findobj('Tag', 'grafica_multi');
h_e_l   = findobj(gcbf, 'Tag', 'e_l'); 

zz = get(h_auto, 'ylim');

min_Z_actual = zz(1) + margen_auto;
max_Z_actual = zz(2) - margen_auto;

ampli   = str2num(get(handles.edit6,'string'));
%h_Mpath = findobj(gcbf, 'Tag', 'ampli_Mpath');

z = get(handles.edit6,'UserData');
max_D_actual = z(2);


%h_fix = findobj(gcbf, 'Tag', 'fix');
nueva = get(handles.fix, 'UserData');
fix=get(handles.fix, 'Value');
%%
if val==1 && prev==0
    prev = 1;
    fix = fix&prev;
elseif val ==2 && prev==1
    set(handles.color_senal, 'String', rand(1, 3))
    color_linea=get(handles.color_senal, 'String');
    fix = fix||prev;
    prev = 0;
end

if fix == 1
   
    set(h_auto,  'NextPlot', 'add'); 
    set(h_multi, 'NextPlot', 'add');
    
    min_Z_actual = min ([min_Z_actual min(Z)]);
    
    max_Z_actual = max([max_Z_actual max(Z)]);
    
    max_D_actual = max([max_D_actual max(D)]) ;

    rotulos
    %lista = get(h_panel,  'UserData');
    lista = signal;
        
    if nueva == 1
        rotulo  = lista;
    else
        lista = signal;
        %lista(end) = cellstr(etiqueta);
           
        rotulo  = lista;
    end
        
else
    set(h_auto,  'NextPlot', 'replace')
    set(h_multi, 'NextPlot', 'replace')
    
    min_Z_actual = min(Z);
    max_Z_actual = max(Z);
    max_D_actual = max(D);
    
    rotulos
    rotulo  = (etiqueta) ;
end

set(handles.edit6,'userData', [-max_D_actual max_D_actual])

%% Pintemos los datos 

if nueva == 1 || fix == 0      % si es una gráfica nueva la pintamos
    sigley =strcat('Seal ', string(val),' En Fase multipath');
    sigley2 =strcat('Seal ', string(val),' Contrafase multipath');
    sigley3 =strcat('Seal ', string(val),' Autocorrelacin');
    
    X1=plot(auto, [ -1.2 -1 eje_x +1 1.2 ], [0 0 Z 0 0],...
        'Color', str2num(color_linea), 'LineWidth', 1, 'Tag', 'er_plot','DisplayName',sigley3);
    X1.LineWidth = 1.5;
    X2=plot(multi, eje_error, D,...
    'Color', str2num(color_linea),'LineWidth', 1, 'Tag', 'er_plot2','DisplayName',sigley);
    X2.LineWidth = 1.5;
    %X2.Marker = '+';
    set(h_multi, 'NextPlot', 'add')

    X3=plot(multi, [eje_error_min dur_chips_x*m_x_chip 1.65*m_x_chip], [error_min 0 0],...
   'Color', str2num(color_linea),'LineWidth', 1, 'Tag', 'er_plot3', 'DisplayName',sigley2);
   X3.LineWidth = 1.5;     
else    % Si no, simplemente coloreamos con el color que debe tener
    
    h_plot = findobj(gcbf, 'Tag', 'er_plot');
    set(h_plot(1),'Color', str2num(color_linea))

    h_plot2 = findobj(gcbf, 'Tag', 'er_plot2');
    set(h_plot2(1),'Color', str2num(color_linea))

    h_plot3 = findobj(gcbf, 'Tag', 'er_plot3');
    set(h_plot3(1),'Color', str2num(color_linea))

end

% La leyenda
set(h_panel,  'UserData', rotulo);

%leyenda = legend(h_auto, cellstr(get(h_panel, 'UserData')));
%set(leyenda,'Position',[0.775 0.895 0.01 0.01 ],'FontSize',8)
if val==1 && prev==1
    %legend(h_multi,'Seal 1');
    %leyenda = legend(h_auto, cellstr(get(h_panel, 'UserData')));
    %str = {'Seal 1',num2str(BW)};
    %text((0-INITCROSS(2)/3),0-MIDLEV*0.1,str,'Color','blue','FontSize',11);
elseif val ==2 && prev==0
    %legend(h_multi,'Seal 1','Seal 2 :');
end
% Ejes
ylim(h_auto, [min_Z_actual-margen_auto max_Z_actual+margen_auto])
xlim(h_auto,[ -1.2 1.2])

xlabel({'Retardo del multipath [m]'});
ylabel({'Error [m]'});

xlim(h_multi,[0 1.65]*m_x_chip)
ylim(h_multi,[-max_D_actual max_D_actual]*1.1)

xlabel({'Multipath delay [m]'});
ylabel({'Code Tracking Error (m)'});


% Rejilla
grid(h_auto,  'on')
grid(h_multi, 'on')
%sigley =strcat('Seal con Early-late de :', string(d));
% if val==1 && prev==1
%     legend(h_multi,[X2],sigley)
%     hold on;
% elseif val ==2 && prev==0
%     legend(h_multi,[X3],sigley)
%     hold off;
% end

legend(h_auto);
legend(h_multi);



