function [X,freq]=shcenteredFFT(x,Fs)
% this is a custom function that helps in plotting the autocorrelation two-sided
% spectrum
% x is the signal that is to be transformed
% Fs is the sampling rate
N=length(x);
% frequency axis
if mod(N,2)==0
    k=-N/2:N/2-1; % N even
else
    k=-(N-1)/2:(N-1)/2; % N odd
end
T=N/Fs;
freq=k/T;  %the frequency axis
xs=fftshift(x); %to avoid error in the phase
% takes the fft of the signal, and adjusts the amplitude accordingly
X=fft(xs)/N; % normalize the data
X=fftshift(X); %shifts the fft data so that it is centered